package cn.com.ctop.kuaishou.modules.dimension.controller;

import cn.com.ctop.common.module.utils.QueryGenerator;
import cn.com.ctop.kuaishou.modules.dimension.entity.KuaiShouDimensionAgeConfig;
import cn.com.ctop.kuaishou.modules.dimension.service.IKuaiShouDimensionAgeConfigService;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 素材多维度年龄配置
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-07-29
 */
@Slf4j
@Api(tags = "素材多维度年龄配置")
@RestController
@RequestMapping("/dimension/kuaiShouDimensionAgeConfig")
public class KuaiShouDimensionAgeConfigController {
    @Autowired
    private IKuaiShouDimensionAgeConfigService kuaiShouDimensionAgeConfigService;

    /**
     * 分页列表查询
     *
     * @return
     */
    @ApiOperation(value = "素材多维度年龄配置-分页列表查询", notes = "素材多维度年龄配置-分页列表查询")
    @GetMapping(value = "/list")
    public Result<List<KuaiShouDimensionAgeConfig>> queryPageList() {
        Result<List<KuaiShouDimensionAgeConfig>> result = new Result<>();
        QueryWrapper<KuaiShouDimensionAgeConfig> queryWrapper = new QueryWrapper<>();
        List<KuaiShouDimensionAgeConfig> list = kuaiShouDimensionAgeConfigService.list(queryWrapper);
        result.setSuccess(true);
        result.setResult(list);
        return result;
    }

    /**
     * 添加
     *
     * @param kuaiShouDimensionAgeConfig
     * @return
     */
    @ApiOperation(value = "素材多维度年龄配置-添加", notes = "素材多维度年龄配置-添加")
    @PostMapping(value = "/add")
    public Result<KuaiShouDimensionAgeConfig> add(@RequestBody KuaiShouDimensionAgeConfig kuaiShouDimensionAgeConfig) {
        Result<KuaiShouDimensionAgeConfig> result = new Result<>();
        try {
            kuaiShouDimensionAgeConfigService.save(kuaiShouDimensionAgeConfig);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param kuaiShouDimensionAgeConfig
     * @return
     */
    @ApiOperation(value = "素材多维度年龄配置-编辑", notes = "素材多维度年龄配置-编辑")
    @PutMapping(value = "/edit")
    public Result<KuaiShouDimensionAgeConfig> edit(@RequestBody KuaiShouDimensionAgeConfig kuaiShouDimensionAgeConfig) {
        Result<KuaiShouDimensionAgeConfig> result = new Result<KuaiShouDimensionAgeConfig>();
        KuaiShouDimensionAgeConfig kuaiShouDimensionAgeConfigEntity = kuaiShouDimensionAgeConfigService.getById(kuaiShouDimensionAgeConfig.getId());
        if (kuaiShouDimensionAgeConfigEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = kuaiShouDimensionAgeConfigService.updateById(kuaiShouDimensionAgeConfig);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "素材多维度年龄配置-通过id删除", notes = "素材多维度年龄配置-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id") String id) {
        try {
            kuaiShouDimensionAgeConfigService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @ApiOperation(value = "素材多维度年龄配置-批量删除", notes = "素材多维度年龄配置-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<KuaiShouDimensionAgeConfig> deleteBatch(@RequestParam(name = "ids") String ids) {
        Result<KuaiShouDimensionAgeConfig> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.kuaiShouDimensionAgeConfigService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "素材多维度年龄配置-通过id查询", notes = "素材多维度年龄配置-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<KuaiShouDimensionAgeConfig> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<KuaiShouDimensionAgeConfig> result = new Result<>();
        KuaiShouDimensionAgeConfig kuaiShouDimensionAgeConfig = kuaiShouDimensionAgeConfigService.getById(id);
        if (kuaiShouDimensionAgeConfig == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(kuaiShouDimensionAgeConfig);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<KuaiShouDimensionAgeConfig> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                KuaiShouDimensionAgeConfig kuaiShouDimensionAgeConfig = JSON.parseObject(deString, KuaiShouDimensionAgeConfig.class);
                queryWrapper = QueryGenerator.initQueryWrapper(kuaiShouDimensionAgeConfig, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<KuaiShouDimensionAgeConfig> pageList = kuaiShouDimensionAgeConfigService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "素材多维度年龄配置列表");
        mv.addObject(NormalExcelConstants.CLASS, KuaiShouDimensionAgeConfig.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("素材多维度年龄配置列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<KuaiShouDimensionAgeConfig> listKuaiShouDimensionAgeConfigs = ExcelImportUtil.importExcel(file.getInputStream(), KuaiShouDimensionAgeConfig.class, params);
                kuaiShouDimensionAgeConfigService.saveBatch(listKuaiShouDimensionAgeConfigs);
                return Result.ok("文件导入成功！数据行数:" + listKuaiShouDimensionAgeConfigs.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
